# LazQuadTree

## Name
LazQuadTree - a quadtree for Lazarurs/FreePascal

## Description
A quad-tree is a tree data structure in which each internal node has exactly four children. 
Details are found here: https://en.wikipedia.org/wiki/Quadtree
The TLazQuadTree class allows the organization of arbitrary two dimensional data, for a quick access.
The class (and some helpers) are open for all kind of data, include the loading and writing to a file.
Descent access methods are defined to help the tree construction and analysis.

Several sample applications gives a fast impression about the functionality and may help building Your own applications.

## Installation
There is nothing to install within Lazarus, since no components are created.
Only the MapViewer-Example needs the existence of the LazMapViewer-Component.
https://wiki.lazarus.freepascal.org/LazMapViewer
But even this component must be only present as file, but not installed within the Lazarus-ide, since the component is instantiated during runtime.

## Usage
See the Examples in the Examples-folder.
There exists a BareBone, a BasicTest (more comprehensive as the name suggests) and the MapViewer-Example.
Additionally a GeometricTest exists, to show the details of the underlying geometrical ideas.

![alt text](docs/screenshots/LazQuadTreeBasicTest_02.jpg "Basic Test") 

## Support
Support is given via this page. If in doubt, you may contact me by e-mail ekkehard@domning.eu

## Roadmap
Not really a roadmap, but thread interlocking will be in the pipeline.

## Contributing
Contribution is welcome, let me know about your ideas

## Authors and acknowledgment
None others than me so far.

## License
Modified LGPL (also referred to as FPC modified LGPL) is the Library GNU General Public License with the following modification:

As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.

Please do not use the software to damage the planet and it's inhabitants!

## Project status
Active